# -*- coding: utf8 -*-
from __future__ import division

import glob
import os
import shutil

from PIL import Image, ImageFont, ImageDraw

TMP_DIR = "tmp_frames"
TMP_AVI = "tmp.avi"
FINAL_DV = "final.dv"


textos = u"""
Un día Felipe preguntó,

- Mamá, ¿dónde están
  los hijos antes de nacer?

- En el deseo de los papás
  de tener hijitos!

El tiempo pasó y... en Julio
de 2012 nos enteramos que
seríamos papás otra vez!!!

Cuando Felu era pequeño una
tarde comenzó a correr a
una mariposa al canto de
¡MALE, MALE!

Cuando nos dijeron que eras
una nena supimos que
serías nuestra mariposita!
""".split("\n")

#Disfrutamos un año intenso con
#nuestra chispita alegre,
#¡y hoy queremos celebrarlo!
#""".split("\n")

TAMANIO = (1024, 768)
CANTBLEND = 30
PASO = 2
BACKGROUND_COLOR = (20, 150, 20)

font = ImageFont.truetype("fonts/Caricaturista.ttf", 62, encoding="unic")
background = Image.new("RGB", TAMANIO, BACKGROUND_COLOR)

def blend(img, paso):
    factor = paso/CANTBLEND
    return Image.blend(img, background, factor)

def dibuja():
    iniy = 768/2+20
    blends = CANTBLEND
    while True:
        img = Image.new("RGB", TAMANIO, BACKGROUND_COLOR)
        draw = ImageDraw.Draw(img)
        posy = iniy
        for t in textos:
            (ancho, alto) = font.getsize(t)
            inix = 1024/2 - ancho/2
            draw.text((inix,posy), t, font=font)
            posy += 90
        if posy < 0:
            return
        iniy -= PASO
        if blends > 0:
            img = blend(img, blends)
            blends -= 1
        yield img

# assure it's clean
if os.path.exists(TMP_DIR):
    shutil.rmtree(TMP_DIR)
os.mkdir(TMP_DIR)
if os.path.exists(TMP_AVI):
    os.remove(TMP_AVI)
if os.path.exists(FINAL_DV):
    os.remove(FINAL_DV)

for i, img in enumerate(dibuja()):
    nom = os.path.join(TMP_DIR, "final%05d.jpg" % i)
    img.save(nom, "JPEG")
    print nom

# create a video from all those images
cmd = (
    'mencoder "mf://%s/*.jpg" -ovc lavc -o %s'
    ' -lavcopts vcodec=mjpeg:vbitrate=1152' % (
        TMP_DIR, TMP_AVI)
)
os.system(cmd)

# convert that video to DV format
cmd = "ffmpeg -i %s -target pal-dv %s" % (TMP_AVI, FINAL_DV)
os.system(cmd)

# remove temp files
for nomarch in glob.glob("%s/final?????.jpg" % (TMP_DIR,)):
    os.remove(nomarch)
os.rmdir(TMP_DIR)
os.remove(TMP_AVI)
